package proba;

import java.util.Random;

public class GeneradorU_0_1{
	
	private long a;
	private long b;
	private long c;
	private double x;
	
	public static long DEFAULT_A = 68909602460261;
	public static long DEFAULT_B = (long)Math.pow(2,48);
	public static long DEFAULT_C = 0;
	
	GeneradorU_0_1(long  x0){
		ini(DEFAULT_A,DEFAULT_B,DEFAULT_C,x0);
	}
	
	GeneradorU_0_1(){
		ini(DEFAULT_A,DEFAULT_B,DEFAULT_C,new Random().nextLong());

	}
	
	protected void ini(long a,long b,long c,long x0){
		this.a = a;
		this.b = b;
		this.c = c;
		this.x = x0;

	}
	
	public double obSig(){
		x = (a * x + c)	 % b;
		return (double)x / (double) b;
	}	
	
	public long getA(){
		return a;
	}	
	public long getB(){
		return b;
	}	
	public long getC(){
		return c;
	}	

	public void setA(long pA){
		a = pA;	
	}
	public void setB(long pB){
		b = pB;	
	}
	public void setC(long pC){
		c = pC;	
	}
}